#include "stdafx.h"
#include "preview.h"
#include "decode.h"

/* ȂMFCX^eBbNCuŃrhƁAICTL3Dŗ܂B
 * dȂ̂ŁAMFC_Ci~bNCuŃrhĂ܂B
 */

#define _VERSION_	"20020211"
#define VERSION_INFO	"PReView - P/ECE\[Xr[A (" _VERSION_ ")\n" \
			"Copyright (C) 2002 Naoyuki Sawa"

/****************************************************************************
 *	
 ****************************************************************************/

#define WIDTH_MAX	1024	/* ő啝 */
#define HEIGHT_MAX	1024	/* ő卂 */

#define BUFFER_SIZE	(1024 * 1024)	/* Œ512KB͕Kv */
static unsigned char  in_buffer[BUFFER_SIZE];
static unsigned char out_buffer[BUFFER_SIZE];
static int data_length;

static int
unpex()
{
	pffsFileHEADER* fh;
	unsigned crc;

	if(data_length < sizeof(pffsFileHEADER)) return 0; /* wb_菬 */
	fh = (pffsFileHEADER*)in_buffer;
	if(fh->mark != 'X') return 0;
	if(fh->ofs_data < sizeof(pffsFileHEADER)) return 0; /* f[^wb_ɂԂĂ */
	if(fh->length < 8) return 0; /* f[^(TCYCRC͕K{) */
	if(fh->length > BUFFER_SIZE) return 0; /* f[^傫 */
	if((int)(fh->ofs_data + fh->length) > data_length) return 0; /* f[^t@CI[𒴂Ă */

	memcpy(out_buffer, in_buffer + fh->ofs_data, fh->length);
	data_length = zlbdecode(out_buffer + 8, fh->length - 8, in_buffer);
	if(data_length != *(int*)(out_buffer + 0)) return 0; /* TCYႤ */
	calcrc_init();
	crc = calcrc(in_buffer, data_length);
	if(crc != *(unsigned*)(out_buffer + 4)) return 0; /* CRCႤ */

	return 1;
}

/****************************************************************************
 *	CPbmp
 ****************************************************************************/

IMPLEMENT_DYNAMIC(CPbmp, CObject)

/* bhdata𕪂R:
 * Ń}͓Ǝwb_gĂāAvOŕWwb_ɎĂ݂łB
 * ꃍ[hɃwb_𐶐ꍇAwb_̒Ƀf[^Ƃ͌܂B
 * ̎ɔāAĂ܂B
 */
CPbmp::CPbmp(PBMP_FILEHEADER* bh, void* data)
{
	/* Ȃ蔲ȎłB */

	int i, x, y;
	BITMAPINFOHEADER* bi;
	RGBQUAD* rgb;
	HBITMAP hbm;
	unsigned char *p, *m, b;

	memcpy(&m_bh, bh, sizeof(PBMP_FILEHEADER));

	m_bmi = (BITMAPINFO*)malloc(sizeof(BITMAPINFO) + sizeof(RGBQUAD) * 256);
	if(m_bmi == NULL) {
		AfxMessageBox("CPBmp::CPBmp(): malloc() failed.", MB_ICONSTOP | MB_OK);
		AfxAbort();
	}
	bi = &m_bmi->bmiHeader;
	rgb = m_bmi->bmiColors;

	memset(bi, 0, sizeof(BITMAPINFOHEADER));
	bi->biSize = sizeof(BITMAPINFOHEADER);
	bi->biWidth = bh->w;
	bi->biHeight = bh->h;
	bi->biPlanes = 1;
	bi->biBitCount = 8;

	memset(rgb, 0, sizeof(RGBQUAD) * 256);
	if(bh->bpp == 1) {
		rgb[0].rgbRed   =
		rgb[0].rgbGreen =
		rgb[0].rgbBlue  = 255;
	} else {
		for(i = 0; i < 4; i++) {
			rgb[i].rgbRed   =
			rgb[i].rgbGreen =
			rgb[i].rgbBlue  = 85 * (3 - i);
		}
		rgb[4].rgbGreen = 255;
	}

	hbm = CreateDIBSection(NULL, m_bmi, DIB_RGB_COLORS, (void**)&m_bits, NULL, NULL);
	if(hbm == NULL) {
		AfxMessageBox("CPbmp::CPbmp(): CreateDIBSection() failed.\n", MB_ICONSTOP | MB_OK);
		AfxAbort();
	}
	m_bmp.Attach(hbm);

	p = (unsigned char*)data;
	if(bh->mask) {
		m = p + (bh->w * bh->h) / (8 / bh->bpp);
	} else {
		m = NULL;
	}

	for(y = 0; y < bh->h; y++) {
		for(x = 0; x < bh->w; x++) {
			if(bh->bpp == 1) {
				b = (*p >> (7 - (x & 7)) & 1) & 1;
				if((x & 7) == 7) p++;
			} else {
				if(m != NULL && (*m >> (7 - (x & 7)) & 1) == 0) {
					b = 4;
				} else {
					b = *p >> (3 - (x & 3)) * 2 & 3;
				}
				if((x & 3) == 3) p++;
			}
			if(m != NULL && (x & 7) == 7) m++;
			m_bits[bh->w * (bh->h - 1 - y) + x] = b;
		}
	}
}

CPbmp::~CPbmp()
{
	free(m_bmi);
}

CString
CPbmp::str() const
{
	CString s;
	s.Format("%3d~%3d %dbitf[^", m_bh.w, m_bh.h, m_bh.bpp);
	if(m_bh.mask != 0) s += "maskt";
	return s;
}

int
CPbmp::save(FILE* fp) const
{
	int retval, n;
	BITMAPFILEHEADER bf;

	memset(&bf, 0, sizeof bf);
	memcpy(&bf.bfType, "BM", 2);
	bf.bfSize = sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 256 + m_bh.w * m_bh.h;
	bf.bfOffBits = sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 256;
	n = sizeof bf;
	retval = fwrite(&bf, 1, n, fp);
	if(retval != n) return 0;

	n = sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 256;
	retval = fwrite(m_bmi, 1, n, fp);
	if(retval != n) return 0;

	n = m_bh.w * m_bh.h;
	retval = fwrite(m_bits, 1, n, fp);
	if(retval != n) return 0;

	return 1;
}

/****************************************************************************
 *	CMyApp
 ****************************************************************************/

BEGIN_MESSAGE_MAP(CMyApp, CWinApp)
	//{{AFX_MSG_MAP(CMyApp)
	//}}AFX_MSG
END_MESSAGE_MAP()
CMyApp theApp;

CMyApp::CMyApp()
{
}

BOOL
CMyApp::InitInstance()
{
	CMyDlg dlg;
	m_pMainWnd = &dlg;
	dlg.DoModal();
	return FALSE;
}

/****************************************************************************
 *	CMyDlg
 ****************************************************************************/

BEGIN_MESSAGE_MAP(CMyDlg, CDialog)
	//{{AFX_MSG_MAP(CMyDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_LBN_SELCHANGE(IDC_ITEMLIST, OnSelchangeItemlist)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(IDC_SAVEALL, OnSaveall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CMyDlg::CMyDlg(CWnd* pParent)
: CDialog(CMyDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyDlg)
	DDX_Control(pDX, IDC_FILENAME, m_filename);
	DDX_Control(pDX, IDC_ITEMLIST, m_itemlist);
	DDX_Control(pDX, IDC_OPEN, m_open);
	DDX_Control(pDX, IDC_SAVE, m_save);
	DDX_Control(pDX, IDC_SAVEALL, m_saveall);
	DDX_Control(pDX, IDCANCEL, m_cancel);
	//}}AFX_DATA_MAP
}

BOOL
CMyDlg::OnInitDialog()
{
	CMenu* sys_menu;

	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	sys_menu = GetSystemMenu(FALSE);
	sys_menu->AppendMenu(MF_SEPARATOR);
	sys_menu->AppendMenu(MF_STRING, 100, "o[W(&A)...");

	m_viewwnd = new CViewWnd(this);
	close_file();

	return TRUE;
}

void
CMyDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{
	switch(nID) {
	case 100:
		{
			AfxMessageBox(VERSION_INFO, MB_ICONINFORMATION | MB_OK);
			return;
		}
	}

	/* NX֗܂B */
	CDialog::OnSysCommand(nID, lParam);
}

void
CMyDlg::OnPaint()
{
	if(IsIconic()) {
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, (WPARAM)dc.GetSafeHdc());
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
	} else {
		CDialog::OnPaint();
	}
}

HCURSOR
CMyDlg::OnQueryDragIcon()
{
	return (HCURSOR)m_hIcon;
}

void
CMyDlg::OnDestroy()
{
	close_file();
	delete m_viewwnd;

	CDialog::OnDestroy();
}

void
CMyDlg::OnSelchangeItemlist()
{
	int sel;
	CPbmp* pbmp;

	sel = m_itemlist.GetCurSel();
	pbmp = (CPbmp*)m_itemlist.GetItemData(sel);
	m_viewwnd->show(pbmp);
	if(sel != LB_ERR) {
		m_save.EnableWindow(TRUE);
	} else {
		m_save.EnableWindow(FALSE);
	}
}

void
CMyDlg::OnOpen()
{
	open_file();
}

void
CMyDlg::OnSave()
{
	save_file();
}

void
CMyDlg::OnSaveall() 
{
	save_all();
}

int
CMyDlg::open_file()
{
	int retval, odemaru, i;
	CString path;
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	FILE* fp;
	PBMP_FILEHEADER* bh;
	CPbmp* pbmp;

	/* Jt@C₢킹܂B */
	CFileDialog dlg(
		TRUE,
		NULL,
		NULL,
		OFN_HIDEREADONLY,
		"kt@C (*.pex)|*.pex|񈳏kt@C (*.srf)|*.srf|SẴt@C (*.*)|*.*||",
		this);
	retval = dlg.DoModal();
	if(retval != IDOK) return 0;

	/* t@Cǂݍ݂܂B */
	path = dlg.GetPathName();
	fp = fopen(path, "rb");
	if(fp == NULL) {
		AfxMessageBox("t@CJ܂B", MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}
	data_length = fread(in_buffer, 1, BUFFER_SIZE, fp);
	fclose(fp);
	if(data_length <= 0) {
		AfxMessageBox("t@Cǂ߂܂B", MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}

	close_file(); /* Ō݂̃f[^jI */

	/* pext@CȂAWJ܂B */
	_splitpath(path, NULL, NULL, fname, ext);
	if(strcmpi(ext, ".pex") == 0) {
		retval = unpex();
		if(!retval) {
			AfxMessageBox("t@CWJł܂B", MB_ICONEXCLAMATION | MB_OK);
			return 0;
		}
	}

	odemaru = strcmpi(fname, "odemaru") == 0 && strcmpi(ext, ".grp") == 0;
	for(i = 0; i < (int)(data_length - sizeof(PBMP_FILEHEADER)); i++) {
		bh = (PBMP_FILEHEADER*)(in_buffer + i);

		if(strncmp((char*)&bh->head, "PMBP", 4) != 0) continue; /* VOl`Ⴄ */
		if(odemaru) {
			decode(out_buffer, (BYTE*)bh - 5);
			bh = (PBMP_FILEHEADER*)out_buffer;
		}
		if(bh->fsize < sizeof(PBMP_FILEHEADER)) continue; /* wb_菬 */
		if(!odemaru) {
			if((int)(i + bh->fsize) > data_length) continue; /* t@CI[𒴂Ă */
		}
		if(bh->w <= 0 || WIDTH_MAX < bh->w) continue; /* 傫 */
		if(bh->h <= 0 || HEIGHT_MAX < bh->h) continue; /* 傫 */
		if(bh->buf_size <= 0) continue; /* f[^ */
		if(sizeof(PBMP_FILEHEADER) + bh->buf_size > bh->fsize) continue; /* t@CI[𒴂Ă */

		if(bh->mask == 0) {
			if(bh->bpp == 1 || bh->bpp == 2) {
				pbmp = new CPbmp(bh, bh + 1);
			}
		} if(bh->mask == 1) {
			if(bh->bpp == 2) {
				pbmp = new CPbmp(bh, bh + 1);
			}
		}
		m_pbmplist.AddTail(pbmp);

		retval = m_itemlist.AddString(pbmp->str());
		m_itemlist.SetItemData(retval, (DWORD)pbmp);
	}

	/* Rg[̍ĐݒB */
	m_filename.SetWindowText(path);
	m_itemlist.EnableWindow(TRUE);
	m_itemlist.SetFocus();
	if(m_itemlist.GetCount() != 0) {
		m_itemlist.SetCurSel(0); /* R[hőIƂ */
		OnSelchangeItemlist();   /* SelChange͗ȂB*/
		m_saveall.EnableWindow(TRUE);
	}

	return 1;
}

void
CMyDlg::close_file()
{
	m_viewwnd->hide();

	m_filename.SetWindowText(NULL);
	m_itemlist.ResetContent();
	m_itemlist.EnableWindow(FALSE);
	m_save.EnableWindow(FALSE);
	m_saveall.EnableWindow(FALSE);
	m_open.SetFocus();

	while(!m_pbmplist.IsEmpty()) delete m_pbmplist.RemoveHead();
}

int
CMyDlg::save_file()
{
	int retval, sel;
	CPbmp* pbmp;
	CString path;
	FILE* fp;

	/* ݂̑IACe擾܂B */
	sel = m_itemlist.GetCurSel();
	if(sel == LB_ERR) return 0;
	pbmp = (CPbmp*)m_itemlist.GetItemData(sel);

	/* ۑt@C₢킹܂B */
	CFileDialog dlg(
		FALSE,
		".bmp", /* ftHggq */
		NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"rbg}bv (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||",
		this);
	retval = dlg.DoModal();
	if(retval != IDOK) return 0;

	path = dlg.GetPathName();
	fp = fopen(path, "wb");
	if(fp == NULL) {
		AfxMessageBox("t@C쐬ł܂B", MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}
	retval = pbmp->save(fp);
	fclose(fp);
	if(!retval) {
		AfxMessageBox("t@C̍쐬Ɏs܂B", MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}

	return 1;
}

int
CMyDlg::save_all()
{
	int retval, n, i;
	POSITION pos;
	CPbmp* pbmp;
	CString path, fname2;
	char path2[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	FILE* fp;
	const char* fmt;

	/* ۑt@C̃vtBNX₢킹܂B */
	CFileDialog dlg(
		FALSE,
		".bmp", /* ftHggq */
		NULL,
		OFN_HIDEREADONLY,
		"rbg}bv (*.bmp)|*.bmp|SẴt@C (*.*)|*.*||",
		this);
	retval = dlg.DoModal();
	if(retval != IDOK) return 0;

	/* vtBNX𕪉܂B */
	path = dlg.GetPathName();
	_splitpath(path, drive, dir, fname, ext);

	/* t@C̒悤ɁATtBbNX̏Iт܂B */
	n = m_pbmplist.GetCount();
	if(n < 10) {
		fmt = "%s%01d";
	} else if(n < 100) {
		fmt = "%s%02d";
	} else if(n < 1000) {
		fmt = "%s%03d";
	} else {
		fmt = "%s%d";
	}

	pos = m_pbmplist.GetHeadPosition();
	i = 0;
	while(pos != NULL) {
		pbmp = m_pbmplist.GetNext(pos);
		fname2.Format(fmt, fname, i++);
		_makepath(path2, drive, dir, fname2, ext);

		fp = fopen(path2, "wb");
		if(fp == NULL) {
			AfxMessageBox(fname2 + " - t@C쐬ł܂B", MB_ICONEXCLAMATION | MB_OK);
			return 0;
		}
		retval = pbmp->save(fp);
		fclose(fp);
		if(!retval) {
			AfxMessageBox(fname2 + " - t@C̍쐬Ɏs܂B", MB_ICONEXCLAMATION | MB_OK);
			return 0;
		}
	}

	return 1;
}

/****************************************************************************
 *	CViewWnd
 ****************************************************************************/

BEGIN_MESSAGE_MAP(CViewWnd, CWnd)
	//{{AFX_MSG_MAP(CViewWnd)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CViewWnd::CViewWnd(CWnd* parent)
{
	int retval;
	const char* class_name;
	CRect parent_rect;

	/* EChENXo^܂B
	 * ڈȍ~͓NXԂ܂B
	 */
	class_name = AfxRegisterWndClass(0);
	if(class_name == NULL) {
		TRACE("CMsgWnd::CMsgWnd: AfxRegisterWndClass failed\n");
		return; /* i\Ȃ */
	}

	/* |bvAbvEChE쐬܂B
	 * ܂\܂B
	 */
	retval = CreateEx(
		WS_EX_TOOLWINDOW,			/* gX^C */
		class_name,				/* NX */
		NULL,					/* EChE^Cg */
		WS_POPUP | WS_CAPTION | WS_BORDER,	/* EChEX^C */
		0, 0, 100, 100,				/* ʒuETCY(0,0,0,0NCTCYԈႤ_) */
		parent->m_hWnd,				/* eEChE */
		NULL);					/* j[ */
	if(!retval) {
		TRACE("CViewWnd::CViewWnd(): CraeteEx() failed\n");
		AfxAbort();
	}

	m_pbmp = NULL;
}

CViewWnd::~CViewWnd()
{
	if(m_hWnd == NULL) return;

	DestroyWindow();
}

void
CViewWnd::show(CPbmp* pbmp)
{
	CRect window_rect, client_rect;
	CSize nc_size;

	if(m_hWnd == NULL) return;

	if(pbmp == NULL) {
		hide();
		return;
	}

	GetWindowRect(&window_rect);
	GetClientRect(&client_rect);
	nc_size.cx = window_rect.Width() - client_rect.Width();
	nc_size.cy = window_rect.Height() - client_rect.Height();
	if(m_pbmp == NULL) GetParent()->GetWindowRect(&window_rect);
	MoveWindow(window_rect.left, window_rect.top,
		nc_size.cx + pbmp->m_bh.w, nc_size.cy + pbmp->m_bh.h);

	m_pbmp = pbmp;
	ShowWindow(SW_SHOWNOACTIVATE);
	Invalidate();
}

void
CViewWnd::hide()
{
	if(m_hWnd == NULL) return;

	m_pbmp = NULL;
	ShowWindow(SW_HIDE);
}

BOOL
CViewWnd::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE;
}

void
CViewWnd::OnPaint() 
{
	int retval;
	CPaintDC dc(this);
	CDC memDC;
	CBitmap* old_bmp;

	if(m_pbmp == NULL) return;

	retval = memDC.CreateCompatibleDC(&dc);
	if(!retval) {
		AfxMessageBox("CViewWnd::OnPaint(): CreateCompatibleDC() failed.", MB_ICONSTOP | MB_OK);
		AfxAbort();
	}

	old_bmp = memDC.SelectObject(&m_pbmp->m_bmp);
	if(old_bmp == NULL) {
		AfxMessageBox("CViewWnd::OnPaint(): SelectObject() failed.", MB_ICONSTOP | MB_OK);
		AfxAbort();
	}
	retval = dc.BitBlt(0, 0, m_pbmp->m_bh.w, m_pbmp->m_bh.h, &memDC, 0, 0, SRCCOPY);
	if(!retval) {
		AfxMessageBox("CViewWnd::OnPaint(): BitBlt() failed.", MB_ICONSTOP | MB_OK);
		AfxAbort();
	}
	memDC.SelectObject(old_bmp);
}
